; @echo off
; tasm /m2 mode64.bat
; pause
; if errorlevel 1 goto exit

; tlink /32 /x  mode64.obj
; del mode64.obj
; pause
; goto exit


.586P

assume		cs:cseg,ds:dseg,ss:sseg

sseg		segment stack 'stack' use16
		db 80h dup (0)
sseg		ends


cseg		segment use16

linear		proc
		movzx eax,bx
		shl eax,4
		ret
linear		endp

er:		lea dx,info
		mov ah,9
		int 21h
		mov dx,si
		mov ah,9
		int 21h
		lea dx,press
		mov ah,9
		int 21h
		mov ah,8
		int 21h
		jmp ex

start:		mov ax,dseg
		mov ds,ax
		lea si,notsupport

		push sp
		pop ax
		cmp ax,sp
		jne short er

		mov bx,0fff0h
		smsw ax
		and ax,bx
		cmp ax,bx
		je short er

		pushfd
		pop eax
		mov ebx,eax
		btc eax,21
		push eax
		popfd
		pushfd
		pop eax
;		push ebx
;		popfd
		cmp ebx,eax
		je er


		mov eax,80000000h
		mov edi,eax
		inc di
		cpuid
		cmp eax,edi
		jb er

		mov al,1
		cpuid
		bt edx,29
		jnc er


		lea si,bootmess
		pushfd
		pop eax
		bt eax,17
		jc er

		mov bx,ds
		call linear
		mov addrgdt,eax

		and bx,0ff00h
		add bx,200h
		call linear
		mov cr3,eax

		push ds
		mov ds,bx
		xor edi,edi
		xor si,si
		mov al,7

		mov cx,3
again1:		add eax,1000h
		mov [si],eax
		mov [si+4],edi
		add si,1000h
		loop again1

		mov cx,100h
		xor eax,eax
		mov al,7
again2:		mov [si],eax
		mov [si+4],edi
		add eax,1000h
		add si,8
		loop again2

		pop ds

		mov bx,cs
		mov segaddr,bx
		call linear
		mov lowbase,ax
		shr eax,16
		mov middbase,al

		mov bx,cseg32
		call linear
		mov addr32,eax	

		assume ds:cseg32
		push ds
		push eax
		mov ds,bx
		mov bx,cseg64
		call linear
		mov addr64,eax
		pop eax
		add eax,offset ret32
		mov ds,bx

		assume ds:cseg64
		mov to32,eax
		pop ds

		assume ds:dseg
		cli
		lgdt pdescr
		mov eax,cr0
		or al,1
		mov cr0,eax

		db 66h
		db 0eah
addr32		dd ?
		dw 8


ret16:		mov eax,cr0
		and al,0feh
		mov cr0,eax

		db 0eah
		dw offset return
segaddr		dw ?

return:		sti
ex:		mov ax,4c00h
		int 21h

cseg		ends


cseg32		segment use32
		mov eax,cr4
		bts eax,5
		mov cr4,eax

		mov ecx,0c0000080h
		rdmsr
		bts eax,8
		wrmsr


		mov eax,cr0
		bts eax,31
		mov cr0,eax

		db 0eah
addr64		dd ?
		dw 10h

ret32		label word
		mov eax,cr0
		btr eax,31
		mov cr0,eax

		mov ecx,0c0000080h
		rdmsr
		btr eax,8
		wrmsr

		mov eax,cr4
		btr eax,5
		mov cr4,eax

		db 66h
		db 0eah
		dw offset ret16
		dw 18h
cseg32		ends


cseg64		segment
		db 48h
		db 0b8h
		db '',7,'',7,'',7,'',7

		db 48h
		db 0a3h
		dd 0b8f00h,0

		db 48h,0b8h
		db '',7,'',7,' ',7,'',7
		db 48h,0a3h
		dd 0b8f08h,0

		db 48h,0b8h
		db '',7,' ',7,'6',7,'4',7
		db 48h,0a3h
		dd 0b8f10h,0

		db 48h,0b8h
		db '-',7,'',7,'',7,'',7
		db 48h,0a3h
		dd 0b8f18h,0

		db 48h,0b8h
		db '',7,'',7,'',7,'',7
		db 48h,0a3h
		dd 0b8f20h,0

		db 48h,0b8h
		db ' ',7,'',7,'',7,'',7
		db 48h,0a3h
		dd 0b8f28h,0

		db 48h,0b8h
		db '',7,'',7,'',7,'!',7
		db 48h,0a3h
		dd 0b8f30h,0

		db 0ffh,2dh
		dd 0

to32		dd ?
		dw 8

cseg64		ends


dseg		segment use16

gdt		dd 0,0

entry1		dw 0ffffh
		dw 0
		db 0
		db 10011000b
		db 01001111b
		db 0

entry2		dw 0
		dw 0
		db 0
		db 10011000b
		db 00100000b
		db 0

entry3		dw 0ffffh
lowbase		dw ?
middbase	db ?
		db 10011010b
		db 0
		db 0
lengdt		equ $-gdt

pdescr		label fword
		dw lengdt-1
addrgdt		dd ?

info		db ' ॢ   64- ०  ⭮'
		db 13,10,13,10,'$'
notsupport	db '  ন  ஬$'
bootmess	db 'ॡ  MS-DOS$'
press		db 13,10,13,10,'  ...$'

dseg		ends

end		start

:exit
